/* \file directexecutor
 * \brief Run commands in the current thread
 */

/*
  Originally written by Doug Lea and released into the public domain.
  This may be used for any purposes whatsoever without acknowledgment.
  Thanks for the assistance and support of Sun Microsystems Labs,
  and everyone contributing, testing, and using this code.

  History:
  Date       Who                What
	01May2004  Mike Swieton     Translated to D
  19Jun1998  dl               Create public version
*/

module concurrent.directexecutor;

import concurrent.executor;

/**
 * 
 * An implementation of Executor that runs the command in the current thread
 * 
 **/
class DirectExecutor : Executor {
	public:
  /** 
   * Execute the given command directly in the current thread.
   **/
  void execute(int delegate() command) {
    command();
  }
}
