/* \file threadedexecutor
 * \brief Runs commands in a new thread
 */

/*
  Originally written by Doug Lea and released into the public domain.
  This may be used for any purposes whatsoever without acknowledgment.
  Thanks for the assistance and support of Sun Microsystems Labs,
  and everyone contributing, testing, and using this code.

  History:
  Date       Who                What
	01May2004  Mike Swieton     Translated to D
  21Jun1998  dl               Create public version
  28aug1998  dl               factored out ThreadFactoryUser
*/

module concurrent.threadedexecutor;

import concurrent.executor;
import concurrent.threadfactoryuser;

/**
 * 
 * An implementation of Executor that creates a new
 * Thread that invokes the run method of the supplied command.
 * 
 **/
class ThreadedExecutor : ThreadFactoryUser, Executor {

  /** 
   * Execute the given command in a new thread.
   **/
  public synchronized void execute(int delegate() command) {
    Thread thread = getThreadFactory().newThread(command);
    thread.start();
  }
}
