/* \file threadfactory
 * \brief Interface for a thread factory
 */

/*
  Originally written by Doug Lea and released into the public domain.
  This may be used for any purposes whatsoever without acknowledgment.
  Thanks for the assistance and support of Sun Microsystems Labs,
  and everyone contributing, testing, and using this code.

  History:
  Date       Who                What
	01May2004  Mike Swieton     Translated to D
  30Jun1998  dl               Create public version
*/

module concurrent.threadfactory;

import std.thread;

/**
 * Interface describing any class that can generate
 * new Thread objects. Using ThreadFactories removes
 * hardwiring of calls to <code>new Thread</code>, enabling
 * applications to use special thread subclasses, default
 * prioritization settings, etc.
 * <p>
 **/

interface ThreadFactory {
  /** 
   * Create a new thread that will run the given command when started
   **/
  public Thread newThread(int delegate() command);
}
